#include <string.h>
#include <stdarg.h>

#include "console.h"
#include "common.h"
#include "osd.h"

#include <SDL.h>

#include <ctype.h>

#define	BLNKW	(2)	/* ̗] */
#define	BLNKH	(2)	/* c̗] */


SDL_Surface *JFont::ZFont = NULL;	// SptHgf[^T[tFXւ̃|C^
SDL_Surface *JFont::HFont = NULL;	// ptHgf[^T[tFXւ̃|C^
int JFont::zWidth  = 0;				// Sp̕
int JFont::zHeight = 0;				//           
int JFont::hWidth  = 0;				// p̕
int JFont::hHeight = 0;				//           


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
JFont::JFont( void ){}

////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
JFont::~JFont( void ){}


////////////////////////////////////////////////////////////////
// tHgt@CJ
////////////////////////////////////////////////////////////////
BOOL JFont::OpenFont( char *zfilename, char *hfilename )
{
	// ɓǍ܂Ăj
	CloseFont();
	
	// Ƃ肠TCYw
	hWidth  = FSIZE;
	hHeight = hWidth * 2;
	
	// tHgt@Cǂݍ
	HFont = LoadPNG( hfilename );
	ZFont = LoadPNG( zfilename );
	
	// tHgt@C΃_~[쐬
	if( !HFont ) HFont = SDL_CreateRGBSurface( SDLOP_SURFACE | SDL_SRCCOLORKEY, hWidth*96*2, hHeight* 2, 8, 0, 0, 0, 0 );
	if( !ZFont ) ZFont = SDL_CreateRGBSurface( SDLOP_SURFACE | SDL_SRCCOLORKEY, zWidth*96*2, zHeight*96, 8, 0, 0, 0, 0 );
	
	// pƑSpŃTCYقȂꍇ͏قɍ킹(R\Y)
	hWidth  = min( HFont->w, ZFont->w ) / 96 / 2;
	hHeight = min( HFont->h / 2, ZFont->h / 96 );
	zWidth  = hWidth * 2;
	zHeight = hHeight;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// tHgj
////////////////////////////////////////////////////////////////
void JFont::CloseFont( void )
{
	if( HFont ){
		SDL_FreeSurface( HFont );
		HFont = NULL;
	}
	if( ZFont ){
		SDL_FreeSurface( ZFont );
		ZFont = NULL;
	}
}


////////////////////////////////////////////////////////////////
// p`
////////////////////////////////////////////////////////////////
void JFont::PutCharh( SDL_Surface* dst, int dx, int dy, Uint8 txt, Uint8 fg, Uint8 bg )
{
	int index = txt;
	
	// NbsO
	SDL_Rect sr,dr;
	sr.x = ( index % 128 ) * hWidth;
	sr.y = ( index / 128 ) * hHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = hWidth;
	sr.h = dr.h = hHeight;
	
	// ]
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			PSet( dst, dr.x + x, dr.y + y, (Uint8)( PGet( HFont, sr.x + x, sr.y + y ) ? fg : bg ) );
}


////////////////////////////////////////////////////////////////
// Sp`
////////////////////////////////////////////////////////////////
void JFont::PutCharz( SDL_Surface* dst, int dx, int dy, Uint16 txt, Uint8 fg, Uint8 bg )
{
	Uint8 high = (txt>>8) & 0xff;
	Uint8 low  =  txt     & 0xff;
	
	Convert2Jis( &high, &low );
	int index = ( high - 0x20 ) * 96 + low - 0x20;
	
	// NbsO
	SDL_Rect sr,dr;
	sr.x = ( index % 96 ) * zWidth;
	sr.y = ( index / 96 ) * zHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = zWidth;
	sr.h = dr.h = zHeight;
	
	// ]
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			PSet( dst, dr.x + x, dr.y + y, (Uint8)( PGet( ZFont, sr.x + x, sr.y + y ) ? fg : bg ) );
}







////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
ZCons::ZCons( void )
{
	Surf = NULL;
	Xmax = Ymax = x = y = 0;
	fgc = FC_WHITE;
	bgc = FC_BLACK;
	*Caption = '\0';
	
	pos.x = pos.y = pos.w = pos.h = 0;
}

////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
ZCons::~ZCons( void ){}



////////////////////////////////////////////////////////////////
// R\[쐬(ŃTCYw)
////////////////////////////////////////////////////////////////
SDL_Surface *ZCons::Create( int winx, int winy, const char *caption, int fcol, int bcol )
{
	int winxr = winx * hWidth  + BLNKW * 2;
	int winyr = winy * hHeight + BLNKH * 2;
	
	return CreateRes( winxr, winyr, caption, fcol, bcol );
}


////////////////////////////////////////////////////////////////
// R\[쐬(𑜓xŃTCYw)
////////////////////////////////////////////////////////////////
SDL_Surface *ZCons::CreateRes( int winx, int winy, const char *caption, int fcol, int bcol )
{
	// 쐬ς݂Ȃ炢J
	if( Surf ) SDL_FreeSurface( Surf );
	
	// T[tFX쐬
	Surf = SDL_CreateRGBSurface( SDLOP_SURFACE, winx, winy, 8, 0, 0, 0, 0 );
	if( !Surf ) return NULL;
	// T[tFXŜwiFœhԂ
	SDL_FillRect( Surf, NULL, bcol );
	
	// pbg쐬(Ƃ肠16F)
	SDL_Color col[16];
	for( int i=0; i<16; i++ ){
		col[i].r = (i&4 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
		col[i].g = (i&2 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
		col[i].b = (i&1 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
	}
	if( !SDL_SetColors( Surf, col, 0, 16 ) ){
		SDL_FreeSurface( Surf );
		Surf = NULL;
		return NULL;
	}
	SetColor( fcol, bcol );
	
	pos.w = Surf->w;
	pos.h = Surf->h;
	
	// cő啶ݒ
	Xmax = ( Surf->w - BLNKW * 2 ) / hWidth;
	Ymax = ( Surf->h - BLNKH * 2 ) / hHeight;
	
	// `͈͐ݒ
	con.x = BLNKW;
	con.y = BLNKH;
	con.w = Xmax * hWidth;
	con.h = Ymax * hHeight;
	
	if( caption ){	// LvV(t[)̏ꍇ
		// LvVۑ
		strncpy( Caption, caption, min( Xmax-2, (int)sizeof(Caption)-1 ) );
		
		// t[`
		DrawFrame();
		
		// cő啶ݒ
		Xmax -= 2;
		Ymax -= 2;
		
		// `͈͐ݒ
		con.x += hWidth;
		con.y += hHeight;
		con.w  = Xmax * hWidth;
		con.h  = Ymax * hHeight;
	}
	
	x = y = 0;
	
	return Surf;
}


////////////////////////////////////////////////////////////////
// J[\ʒuݒ
////////////////////////////////////////////////////////////////
void ZCons::Locate( int xx, int yy )
{
	// E[C[`FbN
	// E[C[
	if( ( xx >= 0 )&&( xx < Xmax ) ) x = xx;
	else if( ( xx < 0 )&&( (Xmax-xx)>=0 ) ) x = Xmax + xx;
	
	if( ( yy >= 0 )&&( yy < Ymax ) ) y = yy;
	else if( ( yy < 0 )&&( (Ymax-yy)>=0 ) ) y = Ymax + yy;
}


////////////////////////////////////////////////////////////////
// J[\ʒuݒ(ԐڍW)
////////////////////////////////////////////////////////////////
void ZCons::LocateR( int xx, int yy )
{
	x += xx;
	if( x < 0 ) x = 0;
	if( x >= Xmax ) x = Xmax;
	
	y += yy;
	if( y < 0 ) y = 0;
	if( y >= Ymax ) y = Ymax;
}


////////////////////////////////////////////////////////////////
// `Fݒ
////////////////////////////////////////////////////////////////
void ZCons::SetColor( Uint8 fg, Uint8 bg )
{
	fgc = fg;
	bgc = bg;
}

void ZCons::SetColor( Uint8 fg )
{
	fgc = fg;
}


////////////////////////////////////////////////////////////////
// ʏ
////////////////////////////////////////////////////////////////
void ZCons::Cls( void )
{
	// `͈͂wiFœhԂ
	if( Surf ) SDL_FillRect( Surf, &con, bgc );
	// J[\z[ɖ߂
	x = y = 0;
}


////////////////////////////////////////////////////////////////
// p1`
////////////////////////////////////////////////////////////////
void ZCons::PutCharH( Uint8 c )
{
	JFont::PutCharh( Surf, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// ̃J[\ݒ
	x++;
}


////////////////////////////////////////////////////////////////
// Sp1`
////////////////////////////////////////////////////////////////
void ZCons::PutCharZ( Uint16 c )
{
	JFont::PutCharz( Surf, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// ̃J[\ݒ
	x += 2;
}


////////////////////////////////////////////////////////////////
// t`(䕶Ή)
////////////////////////////////////////////////////////////////
void ZCons::Print( const char *text, ... )
{
	Uint8 buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ϒWJiɕϊj
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// t`(䕶Ή)
////////////////////////////////////////////////////////////////
void ZCons::Printf( const char *text, ... )
{
	Uint8 buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ϒWJiɕϊj
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		switch( buf[i] ){
		case '\n':	// s
			x = 0;
			y++;
			break;
			
		default:	// ʂ̕
			if( isprint( buf[i] ) )
				PutCharH( buf[i] );
			else{
				PutCharZ( buf[i]<<8 | buf[i+1] );
				i++;
			}
			
			// ̃J[\ݒ
			if( x >= Xmax ){
				x = 0;
				y++;
			}
		}
		
		// XN[?
		if( y >= Ymax){
			y = Ymax - 1;
			ScrollUp();
		}
	}
}


////////////////////////////////////////////////////////////////
// t`(El)
////////////////////////////////////////////////////////////////
void ZCons::Printfr( const char *text, ... )
{
	char buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ϒWJiɕϊj
	va_start( ap, text );
	num = vsprintf( buf, text, ap );
	
	if( num > Xmax ) num = Xmax;
	Locate( -num, y );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// g`
////////////////////////////////////////////////////////////////
void ZCons::DrawFrame( void )
{
	SDL_Rect frm;
	
	frm.x = con.x;
	frm.y = con.y + 4;
	frm.w = con.w;
	frm.h = con.h - 8;
	SDL_FillRect( Surf, &frm, fgc );
	
	frm.x += 1;
	frm.y += 1;
	frm.w -= 2;
	frm.h -= 2;
	SDL_FillRect( Surf, &frm, bgc );
	
	// LvV
	if( strlen( Caption ) > 0 ){
		Locate( 1, 0 );
		Print( " %s ", Caption );
	}
}


////////////////////////////////////////////////////////////////
// XN[Abv
////////////////////////////////////////////////////////////////
void ZCons::ScrollUp( void )
{
	SDL_Rect SPos,DPos;
	
	// ]
	SPos.x = con.x;
	SPos.y = con.y + hHeight;
	SPos.w = con.w;
	SPos.h = con.h - hHeight;
	
	// ]
	DPos.x = con.x;
	DPos.y = con.y;
	
	// XN[
	SDL_BlitSurface( Surf, &SPos, Surf, &DPos );
	
	// `͈͂wiFœhԂ
	DPos.x = con.x;
	DPos.y = con.y + con.h - hHeight;
	DPos.w = con.w;
	DPos.h = hHeight;
	SDL_FillRect( Surf, &DPos, bgc );
}


////////////////////////////////////////////////////////////////
// XN[ɕ\
////////////////////////////////////////////////////////////////
void ZCons::Show( SDL_Rect *p )
{
	if( p ){
		pos.x = p->x;
		pos.y = p->y;
	}
	
	SDL_BlitSurface( Surf, NULL, SDL_GetVideoSurface(), &pos );
}
