#ifndef DISK_H_INCLUDED
#define DISK_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "d88.h"
#include "ini.h"

#include "p6device.h"

// őhCuڑ
#define	MAXDRV	2

// ~jtbs[fBXN e
typedef struct{
	int ATN;			// Attention		:R}hMv
	int DAC;			// Data Accepted	:f[^M
	int RFD;			// Ready For Data	:f[^M
	int DAV;			// Data Valid		:f[^M
	
	int command;		// 󂯎R}h
	int step;			// p[^͑҂Xe[^X
	
	int blk;			// ]ubN
	int drv;			// hCuԍ-1
	int trk;			// gbNԍ
	int sct;			// ZN^ԍ
	
	int size;			// oCg
	
	BYTE retdat;		// port D0H Ԃl
	
} DISK60;


// R}h
// ۂɂ PC-80S31 ̃R}hǑ̓H
enum FddCommand
{
	INIT				= 0x00,
	WRITE_DATA			= 0x01,
	READ_DATA			= 0x02,
	SEND_DATA			= 0x03,
	COPY				= 0x04,
	FORMAT				= 0x05,
	SEND_RESULT_STATUS	= 0x06,
	SEND_DRIVE_STATUS	= 0x07,
	TRANSMIT			= 0x11,
	RECEIVE				= 0x12,
	LOAD				= 0x14,
	SAVE				= 0x15,
	
	WAIT				= 0xff,	// ҂̏
	EndofFdcCmd
};

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class DSK6 : public P6DEVENT, public IDoko {
protected:
	int DrvNum;							// hCu
	char FilePath[MAXDRV][PATH_MAX];	// t@CpX
	cD88 *d88[MAXDRV];					// D88IuWFNgւ̃|C^
	BOOL Sys[MAXDRV];					// VXefBXNtO
	
	BOOL SetWait( int, int );			// EFCgݒ
	
public:
	DSK6( VM6 *, const P6ID&, int );	// RXgN^
	virtual ~DSK6();					// fXgN^
	
	virtual void EventCallback( int, int ){}	// CxgR[obN֐
	
	virtual BOOL Init() = 0;			// 
	
	BOOL Mount( int, char * );			// DISK }Eg
	void Unmount( int );				// DISK A}Eg
	
	int GetDrives();					// hCu擾
	
	BOOL IsMount( int );				// }Egς?
	BOOL IsSystem( int );				// VXefBXN?
	BOOL IsProtect( int );				// veNg?
	
	const char *GetFile( int );			// t@CpX擾
	const char *GetName( int );			// DISK擾
};


class DSK60 : public DSK6, public Device {
private:
	DISK60 mdisk;			// ~jtbs[fBXNe
	
	BYTE io_D1H;
	BYTE io_D2H;
	BYTE io_D3H;
	
	BYTE FddIn();			// DISKjbg̃f[^ (port D0H)
	void FddOut( BYTE );	// DISKjbgւ̃R}hCf[^o (port D1H)
	BYTE FddCntIn();		// DISKjbg̐M (port D2H)
	void FddCntOut( BYTE );	// DISKjbgւ̐Mo (port D3H)
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	inline void OutD1H( int, BYTE );
	inline void OutD2H( int, BYTE );
	inline void OutD3H( int, BYTE );
	inline BYTE InD0H( int );
	inline BYTE InD1H( int );
	inline BYTE InD2H( int );
	inline BYTE InD3H( int );
	
public:
	DSK60( VM6 *, const ID&, int );		// RXgN^
	~DSK60();							// fXgN^
	
	BOOL Init();						// 
	
	// foCXID
	enum IDOut{ outD1H=0, outD2H, outD3H };
	enum IDIn {  inD0H=0,  inD1H,  inD2H, inD3H };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


// f[^obt@(256BytesX4)
class cFDCbuf {
protected:
	BYTE Data[4][256];
	int Index[4];
	
public:
	cFDCbuf();							// RXgN^
	~cFDCbuf();							// fXgN^
	
	void Push( int, BYTE );				// f[^obt@Ƀf[^
	BYTE Pop( int );					// f[^obt@f[^o
	
	void Clear( int );					// obt@NA
};


class DSK66 : public DSK6, public Device, public cFDCbuf {
private:
	struct CmdBuffer {
		BYTE Data[10];
		int Index;
	};
	
	CmdBuffer CmdIn;					// R}hobt@
	CmdBuffer CmdOut;					// Xe[^Xobt@
	
	BYTE SRT;							// Step Rate Time V[N쎞ɃhCuɑSTEPM̊Ԋu(ms)
	BYTE HUT;							// Head Unloaded Time
	BYTE HLT;							// Head Load Time
	BOOL NonDMA;						// TRUE:Non DMA[h FALSE:DMA[h
	BYTE SeekST0[4];					// SEEKST0
	BYTE LastCylinder[4];				// ŌɃV[NV_
	BOOL SeekEnd[4];					// V[NtO
	BYTE SendSectors;					// ](100HP)
	BOOL DIO;							// f[^] TRUE: Buffer->CPU FALSE: CPU->Buffer
	
	BYTE Status;						// FDC Xe[^XWX^
	
	void PushStatus( int );				// Xe[^Xobt@Ƀf[^
	BYTE PopStatus();					// Xe[^Xobt@f[^o
	void OutFDC( BYTE );				// FDC ɏ
	BYTE InFDC();						// FDC Ǎ
	void Exec();						// FDC R}hs
	void Specify();						// Specify
	void Read();						// Read
	void Write();						// Write
	void Recalibrate();					// Recalibrate
	void Seek();						// Seek
	void SenseInterruptStatus();		// Sense Interrupt Status
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	inline void OutB1H( int, BYTE );	// FD[hݒ
	inline void OutB2H( int, BYTE );	// FDC INT?
	inline void OutB3H( int, BYTE );	// PortB2h̓o͐
	inline void OutD0H( int, BYTE );	// Buffer
	inline void OutD1H( int, BYTE );	// Buffer
	inline void OutD2H( int, BYTE );	// Buffer
	inline void OutD3H( int, BYTE );	// Buffer
	inline void OutD6H( int, BYTE );	// hCuZNg
	inline void OutD8H( int, BYTE );	// ݕ⏞ ???
	inline void OutDAH( int, BYTE );	// ]ʎw
	inline void OutDDH( int, BYTE );	// FDC f[^WX^
	inline void OutDEH( int, BYTE );	// ?
	
	inline BYTE InB2H( int );			// FDC INT
	inline BYTE InD0H( int );			// Buffer
	inline BYTE InD1H( int );			// Buffer
	inline BYTE InD2H( int );			// Buffer
	inline BYTE InD3H( int );			// Buffer
	inline BYTE InD4H( int );			// ?
	inline BYTE InDCH( int );			// FDC Xe[^XWX^
	inline BYTE InDDH( int );			// FDC f[^WX^

public:
	DSK66( VM6 *, const ID&, int );		// RXgN^
	~DSK66();							// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	BOOL Init();						// 
	
	// foCXID
	enum IDOut{ outB1H=0, outB2H, outB3H, outD0H, outD1H, outD2H,
				outD3H,   outD6H, outD8H, outDAH, outDDH, outDEH };
	enum IDIn {  inB2H=0,  inD0H,  inD1H,  inD2H,  inD3H,  inD4H,  inDCH,  inDDH };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// DISK_H_INCLUDED
