#include <SDL_endian.h>

#include "graph.h"
#include "common.h"
#include "debug.h"
#include "mc6847.h"
#include "osd.h"
#include "status.h"

// ʏEBhETCY
#define	P6WINW		(WBBUF)
#define	P6WINH		(HBBUF)

// tXN[EBhETCY
#define	P6WIFW		(320)
#define	P6WIFH		(200)

#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
// fobO[hEBhETCY
#define	P6DEBUGW	(P6WINW+vm->regw->Width())
#define	P6DEBUGH	(max(P6WINH,vm->regw->Height()+vm->memw->Height())+vm->monw->Height())
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


// j^[h̓tXN[CXLCC4:3\֎~
// tXN[[h̓Xe[^Xo[C4:3\֎~
#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define	DISPMON		(vm->cfg->GetMonDisp())
#define	DISPFULL	(!DISPMON  && vm->cfg->GetFullScreen())
#define	DISPSCAN	(!DISPMON  && vm->cfg->GetScanLine())
#define	DISPNTSC	(!DISPMON  && !DISPFULL && vm->cfg->GetDispNTSC())
#define	DISPSTAT	(!DISPFULL && vm->cfg->GetStatDisp())

#else

#define	DISPFULL	(vm->cfg->GetFullScreen())
#define	DISPSCAN	(vm->cfg->GetScanLine())
#define	DISPNTSC	(vm->cfg->GetDispNTSC() && !DISPFULL )
#define	DISPSTAT	(vm->cfg->GetStatDisp())

#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
DSP6::DSP6( VM6 *vm, const P6ID& id ) : P6DEVICE(vm,id)
{
	SBuf = NULL;
	ScrPos.x = ScrPos.y = ScrPos.w = ScrPos.h = 0;
	Bpp  = DEFAULT_COLOR_MODE;
	SLBr = DEFAULT_SCANLINEBR;
	
	ZeroMemory( GPal, sizeof(SDL_Color)*256 );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
DSP6::~DSP6( void )
{
	if( SBuf && ( SBuf != vm->vdg->GetSurf() ) ) SDL_FreeSurface( SBuf );
}


////////////////////////////////////////////////////////////////
// 
//
// :	Ȃ
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL DSP6::Init( int bpp, int br )
{
	PRINTD( GRP_LOG, "[GRP][Init]\n" );
	
	Bpp  = bpp;
	SLBr = br;
	
	// pbg
	for( int i=0; i<128; i++ ){
		// WJ[ݒ
		SDL_Color col;
		if( vm->cfg->GetColor( i, &col ) ){	// J[f[^擾
			GPal[i].r = col.r;
			GPal[i].g = col.g;
			GPal[i].b = col.b;
		}
		// XLCpJ[ݒ
		GPal[i+128].r = ( GPal[i].r * vm->cfg->GetScanLineBr() ) / 100;
		GPal[i+128].g = ( GPal[i].g * vm->cfg->GetScanLineBr() ) / 100;
		GPal[i+128].b = ( GPal[i].b * vm->cfg->GetScanLineBr() ) / 100;
	}
	
	// obNobt@Ƀpbgݒ
	if( vm->vdg ) SetPalette( vm->vdg->GetSurf() );
	
	// XN[T[tFX쐬
	if( !SetScreenSurface() ) return FALSE;
	
	// Xe[^Xo[
	if( !vm->staw->Init() ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// XN[T[tFX쐬
//
// :	Ȃ
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL DSP6::SetScreenSurface( void )
{
	PRINTD( GRP_LOG, "[GRP][SetScreenSurface]\n" );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// j^[h?
		
		PRINTD2( GRP_LOG, " -> Monitor Mode ( X:%d Y:%d )\n", P6DEBUGW, P6DEBUGH );
		
		if( !SDL_SetVideoMode( P6DEBUGW, P6DEBUGH, Bpp, SDLOP_SCREEN ) ) return FALSE;
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		int x = ( DISPFULL ? P6WIFW : P6WINW ) * ( DISPSCAN ? 2 : 1 );
		int y = ( DISPFULL ? P6WIFH : ( DISPNTSC ? HBBUS : P6WINH ) ) * ( DISPSCAN ? 2 : 1 );
		
		if( DISPFULL ){	// tXN[?
		#ifdef __APPLE__
			// Mac ̃tXN[ 640x480, 800x600, 1024x768 Ɍ炵Bby Windy
			x = 640;
			y = 480;
		#endif
			
			PRINTD2( GRP_LOG, " -> FullScreen ( X:%d Y:%d )\n", x, y );
			
			// }EXJ[\
			SDL_ShowCursor( SDL_DISABLE );
			// XN[T[tFX쐬
			if( !SDL_SetVideoMode( x, y, Bpp, SDLOP_SCREEN | SDL_FULLSCREEN ) ) return FALSE;
			
			PRINTD3( GRP_LOG, " -> OK ( %d x %d x %d )\n", SDL_GetVideoSurface()->w, SDL_GetVideoSurface()->h, SDL_GetVideoSurface()->format->BitsPerPixel );
			
		}else{
			// Xe[^Xo[\?
			if( DISPSTAT ) y += vm->staw->Height();
			
			PRINTD2( GRP_LOG, " -> Window ( X:%d Y:%d )\n", x, y );
			
			// XN[T[tFX쐬
			if( !SDL_SetVideoMode( x, y, Bpp, SDLOP_SCREEN ) ) return FALSE;
		}
	}
	
	// tXN[łȂ?
	if( !DISPFULL ){
		// EBhELvVݒ
		SDL_WM_SetCaption( vm->cfg->GetCaption(), "" );
		// }EXJ[\\
		SDL_ShowCursor( SDL_ENABLE );
	}
	
	// XN[T[tFXɃpbgI
	if( SDL_GetVideoSurface()->format->BitsPerPixel == 8 )
		if( !SetPalette( SDL_GetVideoSurface() ) ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// XN[TCYύX
//
// :	Ȃ
// Ԓl:	SDL_Surface *	XN[T[tFXւ̃|C^
////////////////////////////////////////////////////////////////
SDL_Surface *DSP6::ResizeScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][ResizeScreen]\n" );
	
	int x,y;
	SDL_Surface *scr  = SDL_GetVideoSurface();	// XN[T[tFXւ̃|C^擾
	
	// EBhETCY`FbN
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// j^[h?
		x = P6DEBUGW;
		y = P6DEBUGH;
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		x = ( DISPFULL ? P6WIFW : P6WINW ) * ( DISPSCAN ? 2 : 1 );
		y = ( DISPFULL ? P6WIFH : ( DISPNTSC ? HBBUS : P6WINH ) ) * ( DISPSCAN ? 2 : 1 );
		
		// Xe[^Xo[\?
		if( !DISPFULL && DISPSTAT ) y += vm->staw->Height();
	}
	
	// EBhETCYsK؂Ȃ蒼
	if( !scr || (x != scr->w) || (y != scr->h) ){
		SetScreenSurface();
		vm->staw->Init();	// Xe[^Xo[
	}
	
	return SDL_GetVideoSurface();
}


////////////////////////////////////////////////////////////////
// T[tFXɃpbgݒ
////////////////////////////////////////////////////////////////
BOOL DSP6::SetPalette( SDL_Surface *scr )
{
	PRINTD( GRP_LOG, "[GRP][SetPalette]\n" );
	
	if( SDL_SetColors( scr, GPal, 0, 255 ) ) return TRUE;
	else                                     return FALSE;
}


////////////////////////////////////////////////////////////////
// ʍXV
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::DrawScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][DrawScreen]\n" );
	
	SDL_Surface *scr  = SDL_GetVideoSurface();	// XN[T[tFXւ̃|C^擾
	SDL_Surface *BBuf = vm->vdg->GetSurf();		// obNobt@ւ̃|C^擾
	
	if( !scr || !BBuf ) return;
	
	// XN[T[tFXblit
	PRINTD( GRP_LOG, " -> Blit" );
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// j^[h?
		PRINTD( GRP_LOG, " -> Monitor" );
		
		// obNobt@
		ScrPos.x = 0;
		ScrPos.y = 0;
		SDL_BlitSurface( BBuf, NULL, scr, &ScrPos );
		
		// j^EBhE
		ScrPos.x = 0;
		ScrPos.y = max( P6WINH, vm->regw->Height() + vm->memw->Height() );
		vm->monw->Show( &ScrPos );
		
		// WX^EBhE
		ScrPos.x = P6WINW;
		ScrPos.y = 0;
		vm->regw->Show( &ScrPos );
		
		// EBhE
		ScrPos.x = P6WINW;
		ScrPos.y = vm->regw->Height();
		vm->memw->Show( &ScrPos );
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		UpdateSubBuf();	// Tuobt@XV
		
		if( DISPFULL ){	// tXN[
			PRINTD( GRP_LOG, " -> FullScreen(No 4:3)" );
			// tXN[̎4:3\
			ScrPos.x = ( scr->w - SBuf->w )/2;
			ScrPos.y = ( scr->h - SBuf->h )/2;
			ScrPos.w = SBuf->w;
			ScrPos.h = SBuf->h;
			SDL_BlitSurface( SBuf, NULL, scr, &ScrPos );
		}else{			// tXN[łȂ
			PRINTD( GRP_LOG, " -> Window" );
			SDL_BlitSurface( SBuf, NULL, scr, NULL );
		}
		
		// Xe[^Xo[
		if( DISPSTAT ){
			PRINTD( GRP_LOG, " -> Statusbar" );
			
			// Xe[^Xo[XVblit
			vm->staw->Update();
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	// tbv
 	SDL_Flip( scr );
}


////////////////////////////////////////////////////////////////
// LXN[擾
//
// :	Ȃ
// Ԓl:	int		LXN[sNZ
////////////////////////////////////////////////////////////////
int DSP6::ScreenX( void )
{
	return P6WINW * ( DISPSCAN ? 2 : 1 );
}


////////////////////////////////////////////////////////////////
// LXN[擾
//
// :	Ȃ
// Ԓl:	int		LXN[sNZ
////////////////////////////////////////////////////////////////
int DSP6::ScreenY( void )
{
	return ( DISPNTSC ? HBBUS : P6WINH ) * ( DISPSCAN ? 2 : 1 );
}


////////////////////////////////////////////////////////////////
// Tuobt@XV
//
// :	Ȃ
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
#define	RESO43		(8)		/* ԐFvZp\(1CRESO43) */
#define	THRE43		(0)		/* ԐF̂l(傫ΒԐF) */
BOOL DSP6::UpdateSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][UpdateSubBuf]\n" );
	
	SDL_Surface *BBuf = vm->vdg->GetSurf();
	
	if( !BBuf ) return FALSE;
	
	if( !RefreshSubBuf() ) return FALSE;
	
	if( SDL_MUSTLOCK( BBuf ) ) SDL_LockSurface( BBuf );
	if( SDL_MUSTLOCK( SBuf ) ) SDL_LockSurface( SBuf );
	
	if( DISPNTSC ){	// 4:3\L̏ꍇ
		PRINTD( GRP_LOG, " -> 4:3" );
		if( DISPSCAN ){	// XLC̏ꍇ
			PRINTD( GRP_LOG, " -> ScanLine" );
			switch( SBuf->format->BitsPerPixel ){
			case 8:		// 8bit[h
				PRINTD( GRP_LOG, " -> 8bit" );
				for( int y=0; y<SBuf->h; y+=2 ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					
					DWORD *soff = (DWORD *)BBuf->pixels + BBuf->pitch/sizeof(DWORD) * y0;
					DWORD *doff = (DWORD *)SBuf->pixels + SBuf->pitch/sizeof(DWORD) * y;
					DWORD *eoff = doff + SBuf->pitch/sizeof(DWORD);
					DWORD s, d;
					
					// 8bit̎͒ԐFȂ
					for( int x=0; x<(int)(BBuf->w/sizeof(DWORD)); x++ ){
						BYTE b1,b2,b3,b4;
						s = *soff++;
						DWTOB( s, b1, b2, b3, b4 );
						d = BTODW( b4, b4, b3, b3 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
						d = BTODW( b2, b2, b1, b1 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
					}
				}
				break;
				
			case 16:	// 16bit[h
				PRINTD( GRP_LOG, " -> 16bit" );
				for( int y=0; y<SBuf->h; y+=2 ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					DWORD *doff = (DWORD *)SBuf->pixels + ( SBuf->pitch * y ) / sizeof(DWORD);
					DWORD *eoff = doff + SBuf->pitch / sizeof(DWORD);
					
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							
							BYTE r = ( GPal[d1].r * a2 + GPal[d2].r * a1 ) / RESO43;
							BYTE g = ( GPal[d1].g * a2 + GPal[d2].g * a1 ) / RESO43;
							BYTE b = ( GPal[d1].b * a2 + GPal[d2].b * a1 ) / RESO43;
							
							DWORD dd = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							dd |= dd << 16;
							*(doff++) = dd;
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							DWORD ed = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							ed |= ed << 16;
							*(eoff++) = ed;
						}
					}else{
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = GPal[d1].r;
							BYTE g = GPal[d1].g;
							BYTE b = GPal[d1].b;
							
							DWORD dd = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							dd |= dd << 16;
							*(doff++) = dd;
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							DWORD ed = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							ed |= ed << 16;
							*(eoff++) = ed;
						}
					}
				}
				break;
				
			case 24:	// 24bit[h
				PRINTD( GRP_LOG, " -> 24bit" );
				for( int y=0; y<SBuf->h; y+=2 ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					BYTE *doff = (BYTE *)SBuf->pixels + SBuf->pitch * y;
					BYTE *eoff = doff + SBuf->pitch;
					
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							
							BYTE r = ( GPal[d1].r * a2 + GPal[d2].r * a1 ) / RESO43;
							BYTE g = ( GPal[d1].g * a2 + GPal[d2].g * a1 ) / RESO43;
							BYTE b = ( GPal[d1].b * a2 + GPal[d2].b * a1 ) / RESO43;
							
							PUT3BYTE( b, g, r, doff );
							PUT3BYTE( b, g, r, doff );
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							PUT3BYTE( b, g, r, eoff );
							PUT3BYTE( b, g, r, eoff );
						}
					}else{
						for( int x=0; x<(int)BBuf->w; x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = GPal[d1].r;
							BYTE g = GPal[d1].g;
							BYTE b = GPal[d1].b;
							
							PUT3BYTE( b, g, r, doff );
							PUT3BYTE( b, g, r, doff );
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							PUT3BYTE( b, g, r, eoff );
							PUT3BYTE( b, g, r, eoff );
						}
					}
				}
			}
		}else{			// XLCȂ̏ꍇ
			PRINTD( GRP_LOG, " -> No ScanLine" );
			switch( SBuf->format->BitsPerPixel ){
			case 8:		// 8bit[h
				PRINTD( GRP_LOG, " -> 8bit" );
				for( int y=0; y<SBuf->h; y++ ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					BYTE *doff = (BYTE *)SBuf->pixels + SBuf->pitch * y;
					
					// 8bit̎͒ԐFȂ
					memcpy( doff, soff, SBuf->pitch );
				}
				break;
				
			case 16:	// 16bit[h
				PRINTD( GRP_LOG, " -> 16bit" );
				for( int y=0; y<SBuf->h; y++ ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					WORD *doff = (WORD *)SBuf->pixels + ( SBuf->pitch * y ) / sizeof(WORD);
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							WORD dd = ( (WORD)( ( ( GPal[d1].r * a2 + GPal[d2].r * a1 ) / RESO43 ) & 0xf8 ) << 8 ) |
									  ( (WORD)( ( ( GPal[d1].g * a2 + GPal[d2].g * a1 ) / RESO43 ) & 0xfc ) << 3 ) |
									  ( (WORD)( ( ( GPal[d1].b * a2 + GPal[d2].b * a1 ) / RESO43 ) & 0xf8 ) >> 3 );
							*(doff++) = dd;
						}
					}else{
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff++);
							WORD dd = ( (WORD)( GPal[d1].r & 0xf8 ) << 8 ) |
									  ( (WORD)( GPal[d1].g & 0xfc ) << 3 ) |
									  ( (WORD)( GPal[d1].b & 0xf8 ) >> 3 );
							*(doff++) = dd;
						}
					}
				}
				break;
				
			case 24:	// 24bit[h
				PRINTD( GRP_LOG, " -> 24bit" );
				for( int y=0; y<SBuf->h; y++ ){
					int y0 = ( y * BBuf->h ) / SBuf->h;
					int a1 = ( y * BBuf->h * RESO43 ) / SBuf->h - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->pixels + BBuf->pitch * y0;
					BYTE *doff = (BYTE *)SBuf->pixels + SBuf->pitch * y;
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->pitch);
							
							BYTE r = ( GPal[d1].r * a2 + GPal[d2].r * a1 ) / RESO43;
							BYTE g = ( GPal[d1].g * a2 + GPal[d2].g * a1 ) / RESO43;
							BYTE b = ( GPal[d1].b * a2 + GPal[d2].b * a1 ) / RESO43;
							
							PUT3BYTE( b, g, r, doff );
						}
					}else{
						for( int x=0; x<BBuf->pitch; x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = GPal[d1].r;
							BYTE g = GPal[d1].g;
							BYTE b = GPal[d1].b;
							
							PUT3BYTE( b, g, r, doff );
						}
					}
				}
			}
		}
	}else{			// 4:3\̏ꍇ (8bit[hɌ肳)
		PRINTD( GRP_LOG, " -> No 4:3(8bit)" );
		if( DISPSCAN ){	// XLC̏ꍇ
			PRINTD( GRP_LOG, " -> ScanLine" );
			for( int y=0; y<BBuf->h; y++ ){
				DWORD *soff = (DWORD *)BBuf->pixels + BBuf->pitch/sizeof(DWORD) * y;
				DWORD *doff = (DWORD *)SBuf->pixels + SBuf->pitch/sizeof(DWORD) * y*2;
				DWORD *eoff = doff + SBuf->pitch/sizeof(DWORD);
				DWORD s, d;
				
				for( int x=0; x<(int)(BBuf->w/sizeof(DWORD)); x++ ){
					BYTE b1,b2,b3,b4;
					s = *soff++;
					DWTOB( s, b1, b2, b3, b4 );
					d = BTODW( b4, b4, b3, b3 );
					*doff++ = d;
					*eoff++ = d|0x80808080;
					d = BTODW( b2, b2, b1, b1 );
					*doff++ = d;
					*eoff++ = d|0x80808080;
				}
			}
		}else{			// XLCȂ̏ꍇ
			PRINTD( GRP_LOG, " -> No ScanLine" );
			// ȂɂȂ̂ƓȂ̂ŃpX
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	
	if( SDL_MUSTLOCK( BBuf ) ) SDL_UnlockSurface( BBuf );
	if( SDL_MUSTLOCK( SBuf ) ) SDL_UnlockSurface( SBuf );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// Tuobt@tbV
//
// :	Ȃ
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL DSP6::RefreshSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][RefreshSubBuf]\n" );
	
	SDL_Surface *BBuf = vm->vdg->GetSurf();
	
	if( DISPNTSC || DISPSCAN ){	// 4:3\L ܂ XLC̏ꍇCSBufKv
		if( SBuf && SBuf != BBuf ){
			// TCYςĂȂOK
			if( SBuf->w == ScreenX() && SBuf->h == ScreenY() ){
				PRINTD2( GRP_LOG, " X:%d Y:%d -> OK\n", SBuf->w, SBuf->h );
				return TRUE;
			// ςĂꍇ͈UJ
			}else{
				SDL_FreeSurface( SBuf );
			}
		}
		
		// Tuobt@쐬
		int bpp = DISPNTSC ? Bpp : 8;
		PRINTD3( GRP_LOG, " Create SubBuffer X:%d Y:%d BPP:%d\n", ScreenX(), ScreenY(), bpp );
		SBuf = SDL_CreateRGBSurface( SDLOP_SURFACE, ScreenX(), ScreenY(), bpp, 0, 0, 0, 0 );
		if( !SBuf ) return FALSE;
		
		// pbgݒ
		if( bpp == 8 )
			if( !SetPalette( SBuf ) ) return FALSE;
		
	}else{						// 4:3\  XLCȂ̏ꍇCSBufsv
		if( SBuf && SBuf != BBuf ) SDL_FreeSurface( SBuf );
		SBuf = BBuf;	// Tuobt@ = obNobt@
		PRINTD2( GRP_LOG, " = BackBuffer X:%d Y:%d -> OK\n", SBuf->w, SBuf->h );
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// XibvVbg
//
// :	path	XN[Vbgi[pX
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::SnapShot( char *path )
{
	PRINTD( GRP_LOG, "[GRP][SnapShot]\n" );
	
	char img_file[PATH_MAX];
	char img_name[PATH_MAX] = "P6V";
	char img_ext[]          = ".png";
	int Index = 0;
	
	// XN[Vbgi[tH_Ȃ΃G[
	if( !OSD_FileExist( path ) ) return;
	
	// XN[Vbgt@C߂
	do{
		sprintf( img_file, "%s%s%03d%s", path, img_name, ++Index, img_ext );
	}while( OSD_FileExist( img_file ) || (Index > 999) );
	
	// AԂLȂPNGŕۑ
	if( !(Index > 999) ) SavePNG( img_file, SBuf, NULL );
}


// [] http://www.joochan.net/rgb-convert.html
// RGB <-> YIQ

// Y =  0.2989 * R + 0.5866 * G + 0.1145 * B
// I =  0.5959 * R - 0.2750 * G - 0.3210 * B
// Q =  0.2065 * R - 0.4969 * G + 0.2904 * B

// R = Y + 0.9489 * I + 0.6561 * Q
// G = Y - 0.2645 * I - 0.6847 * Q
// B = Y - 1.1270 * I + 1.8050 * Q
