#ifndef INI_H_INCLUDED
#define INI_H_INCLUDED

#include <limits.h>

#include "pc6001v.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cNode {
public:
	enum NodeType{ NODE_NONE, NODE_COMMENT, NODE_SECTION, NODE_ENTRY };
	
private:
	cNode *PrevNode, *NextNode;
	
public:
	cNode( cNode * );			// RXgN^
	~cNode();					// fXgN^
	
	cNode *AddNode();			// m[hǉ
	
	void SetMember( NodeType, const char * );
	
	NodeType NodeID;	// Node ID
	char *Comment;		// Comments
	char *Section;		// Sections
	char *Entry;		// Entries
	char *Value;
	
	cNode *GetPrevNode(){ return PrevNode; }
	cNode *GetNextNode(){ return NextNode; }
	void SetPrevNode( cNode *node ){ PrevNode = node; }
	void SetNextNode( cNode *node ){ NextNode = node; }
	
};

class cIni {
protected:
	cNode *IniNode;				// 擪m[hւ̃|C^
	char FileName[PATH_MAX];	// t@C
	
	BOOL Ready;
	
public:
	cIni();						// RXgN^
	virtual ~cIni();			// fXgN^
	
	BOOL Init( char * );		// 
	
	BOOL IsReady(){ return Ready; }
	
	BOOL Write();															// 
	BOOL GetString( const char *, const char *, char *, const char * );		// Ǎ
	BOOL GetInt( const char *, const char *, int *, const int );			// lǍ
	BOOL GetTruth( const char *, const char *, BOOL *, const BOOL );		// YesNoǍ
	BOOL PutEntry( const char *, const char *, const char *, const char *, ... );	// Ggǉ
	
};



// ǂłSAVEpC^[tFCX
struct IDoko
{
	virtual BOOL DokoLoad( cIni * ) = 0;
	virtual BOOL DokoSave( cIni * ) = 0;
};

#endif	// INI_H_INCLUDED
