#ifndef KEYBOARD_H_INCLUDED
#define KEYBOARD_H_INCLUDED

#include "pc6001v.h"
#include "ini.h"
#include "joystick.h"
#include "keydef.h"

#include "p6device.h"


// }gNX
#define	NOM			(16)

// L[{[hCWP[^
#define	KI_KANA		(1)
#define	KI_KKANA	(2)
#define	KI_CAPS		(4)


// P6̃L[}gNX}bv`
typedef struct {
	BYTE Keys[8][8];	// L[}gNX}bv
} P6MxMap;


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class KEY6 : public P6DEVENT, public cJoy, public IDoko {
protected:
	PCKEYsym VKTable[SDLK_LAST];	// SDLL[R[h  -> zL[R[h ϊe[u
	P6KEYsym K6Table[KVC_LAST];		// zL[R[h -> P6L[R[h ϊe[u
	BYTE MatTable[KP6_LAST];		// P6L[R[h -> }gNX ϊe[u
	
	// L[ tO
	BOOL ON_SHIFT;	// SHIFT
	BOOL ON_GRAPH;	// GRAPH
	BOOL ON_KANA;	// 
	BOOL ON_KKANA;	// J^Ji
	BOOL ON_CTRL;	// CTRL
	BOOL ON_STOP;	// STOP
	BOOL ON_CAPS;	// CAPS
	
	// L[͏\
	typedef struct{
		char *Buffer;			// L[obt@|C^
		int Num;				// c蕶
		int Wait;				// ҂񐔃JE^
		BOOL Relay;				// [XCb`OFF҂tO
		int Seek;
	} AKEY;
	AKEY ak;					// L[͏
	
	char GetAutoKey();			// L[1擾
	
	BYTE P6Matrix[NOM*2];		// L[}gNX (O: 㔼:O)
	BYTE P6Mtrx[NOM*2];			// L[}gNXۑp
								//  2byte̓WCXeBbN̏ԕۑp

public:
	KEY6( VM6 *, const P6ID& );			// RXgN^
	virtual ~KEY6();					// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	BOOL Init( int );					// 
	
	void UpdateMatrixKey( int, BOOL );	// L[}gNXXV(L[)
	void UpdateMatrixJoy();				// L[}gNXXV(WCXeBbN)
	BOOL ScanMatrix();					// L[}gNXXL
	int GetMatrixSize();				// L[}gNXTCY擾
	BYTE *GetMatrix();					// L[}gNX|C^擾
	BYTE *GetMatrix2();					// L[}gNX|C^(ۑp)擾
	
	BYTE GetKeyJoy();					// J[\L[Ԏ擾
	BYTE GetKeyIndicator();				// L[{[hCWP[^Ԏ擾
	
	BOOL SetAutoKey( char *, int );		// L[͕ݒ
	BOOL SetAutoKeyFile( char * );		// L[͕ݒ(t@C)
	
	void SetVKeySymbols( VKeyConv * );	// zL[R[h -> P6L[R[h ݒ
	
	BYTE GetJoy( int );					// WCXeBbNԎ擾
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class KEY60 : public KEY6 {
public:
	KEY60( VM6 *, const P6ID& );		// RXgN^
	~KEY60();							// fXgN^
};


#endif	// KEYBOARD_H_INCLUDED
