#ifndef MC6847_H_INCLUDED
#define MC6847_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "p6device.h"

// obNobt@TCY
#define	WBBUF		(376-16)	/* K4̔{ */
#define	HBBUF		(242-12)
#define	HBBUS		(282-12)	/* 4:3\ʍ */

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class VDG6 : public P6DEVENT, public IDoko {
protected:
	SDL_Surface *bbuf;		// obNobt@
	
	int Mode4Col;			// [h4J[[h 0:m 1:/ 2:/ 3:sN/ 4:/sN
	BOOL CrtDisp;			// CRT\ TRUE:\ FALSE:\
	BOOL N60Win;			// EBhETCY TRUE:N60 FALSE:N60m
	
	WORD VramAddr;			// VRAM AhX 0:0xc200 1:0xe200 2:0x8200 3:0xa200
	WORD AttrAddr;			// ATTR AhX 0:0xc000 1:0xe000 2:0x8000 3:0xa000
	
	// `揈p[N
	DWORD BCol;				// {[_[J[
	
	// M[N
	int VLines;				// \C
	int VLcnt;				// \CJEgp
	int HWait;				// \ԃEFCg(BUSREQԂCPUNbN)
	
	virtual void SetVramAddr( BYTE ) = 0;	// VRAM AhX؂ւ
	virtual void CrtKill() = 0;				// CRT KILL
	virtual void Vram2Screen() = 0;			// VRAM ̓e obNobt@ɕ`
	
	BOOL RefreshBackBuf();					// obNobt@tbV
	
	BYTE GetAttr( WORD );					// Agr[gf[^擾
	BYTE GetVram( WORD );					// VRAMf[^擾
	
	BYTE GetFont1( WORD );					// Font1f[^擾
	
	void ChangeBUSREQ();					// BUSREQ̕ωʒm
	
	void Putc_M1( int, int, WORD );			// [h1   1PUT
	void Putc_M2( int, int, WORD );			// [h2-1 1PUT
	
	virtual void Mode_12() = 0;				// Mode 1,2 sub
	virtual void Mode_34() = 0;				// Mode 3,4 sub
	
public:
	VDG6( VM6 *, const P6ID& );				// RXgN^
	virtual ~VDG6();						// fXgN^
	
	void EventCallback( int, int );			// CxgR[obN֐
	
	virtual BOOL Init();					// 
	virtual BOOL LoadFont( const char *, const char * ){ return TRUE; }	// VDGtHgǍ
	
	BOOL UpdateBackBuf();					// obNobt@XV
	SDL_Surface *GetSurf(){ return bbuf; }	// obNobt@ւ̃|C^擾
	
	int GetMode4Color(){ return Mode4Col; }	// [h4J[[h擾
	void SetMode4Color( int col ){ Mode4Col = col; }	//        ݒ
	
	BOOL GetWinSize(){ return N60Win; }		// EBhETCY擾
	
	BOOL GetCrtDisp(){ return CrtDisp; }	// CRT\Ԏ擾
	void SetCrtDisp( BOOL );				// CRT\Ԑݒ
	
};


class VDG60 : public VDG6, public Device {
protected:
	BYTE *CGRomV;							// CG ROM(VDG)
	
	void SetVramAddr( BYTE );				// VRAM AhX؂ւ
	void CrtKill();							// CRT KILL
	void Vram2Screen();						// VRAM ̓e obNobt@ɕ`
	
	BYTE GetFontV( WORD );					// VDG Fontf[^擾
	
	void Putc_M0( int, int, WORD );			// [h0   1PUT
	void Putc_M21( int, int, WORD );		// [h2-2 1PUT
	void Mode_12();							// Mode 1,2 sub
	void Mode_34();							// Mode 3,4 sub
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	inline void OutB0H( int, BYTE data ){ SetVramAddr( data ); }
	
public:
	VDG60( VM6 *, const ID& );				// RXgN^
	virtual  ~VDG60();						// fXgN^
	
	BOOL Init();							// 
	BOOL LoadFont( const char *, const char * );		// VDGtHgǍ
	
	// foCXID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class VDG62 : public VDG6, public Device {
protected:
	BOOL Mk2CharMode;						// mk2 \[h TRUE:LN^ FALSE:OtBbN
	BOOL Mk2GraphMode;						// mk2 OtBbN𑜓x TRUE:160*200 FALSE:320*200
	
	int Css1;								// F̑gݍ킹
	int Css2;
	int Css3;
	
	BYTE CrtCtrlPara;						// CRTRg[ɗ^p[^
	
	void SetVramAddr( BYTE );				// VRAM AhX؂ւ
	void CrtKill();							// CRT KILL
	void Vram2Screen();						// VRAM ̓e obNobt@ɕ`
	
	void SetCss( BYTE );					// F̑gw
	void SetCrtControler( BYTE );			// CRTRg[[hݒ
	
	BYTE GetFont2( WORD );					// Font2f[^擾
	
	void Putc_M2( int, int, WORD );			// [N60] [h2 1PUT
	void Putc_M21( int, int, WORD );		// [mk2] [h1 1PUT
	void Mode_12();							// [N60] Mode 1,2 sub
	void Mode_34();							// [N60] Mode 3,4 sub
	void Mode2_1();							// [mk2] Mode 1,2 sub
	void Mode2_3();							// [mk2] Mode 3 sub
	void Mode2_4();							// [mk2] Mode 4 sub
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	inline void OutB0H( int, BYTE data ){ SetVramAddr( data ); }
	inline void OutC0H( int, BYTE data ){ SetCss( data ); }
	inline void OutC1H( int, BYTE data ){ SetCrtControler( data ); }
	inline BYTE InC1H( int ){ return CrtCtrlPara; }
	
public:
	VDG62( VM6 *, const P6ID& );			// RXgN^
	virtual  ~VDG62();						// fXgN^
	
	BOOL Init();							// 
	
	// foCXID
	enum IDOut{ outB0H=0, outC0H, outC1H };
	enum IDIn {  inC1H=0 };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


#endif	// MC6847_H_INCLUDED
